package repository

import (
	"fmt"
	"time"

	"be.ems/src/framework/database/db"
	"be.ems/src/framework/logger"
	"be.ems/src/modules/tool/model"
)

// 实例化数据层 MMLLog 结构体
var NewMMLLog = &MMLLog{}

// MMLLog MML日志 数据层处理
type MMLLog struct{}

// SelectByPage 分页查询集合
func (r MMLLog) SelectByPage(query map[string]string) ([]model.MMLLog, int64) {
	tx := db.DB("").Model(&model.MMLLog{})
	// 查询条件拼接
	if v, ok := query["neType"]; ok && v != "" {
		tx = tx.Where("ne_type = ?", v)
	}
	if v, ok := query["beginTime"]; ok && v != "" {
		if len(v) == 10 {
			v = fmt.Sprintf("%s000", v)
		}
		tx = tx.Where("log_time >= ?", v)
	}
	if v, ok := query["endTime"]; ok && v != "" {
		if len(v) == 10 {
			v = fmt.Sprintf("%s999", v)
		}
		tx = tx.Where("log_time <= ?", v)
	}

	// 查询结果
	var total int64 = 0
	rows := []model.MMLLog{}

	// 查询数量为0直接返回
	if err := tx.Count(&total).Error; err != nil || total <= 0 {
		return rows, total
	}

	// 查询数据分页
	pageNum, pageSize := db.PageNumSize(query["pageNum"], query["pageSize"])
	tx = tx.Limit(pageSize).Offset(pageSize * pageNum)
	err := tx.Find(&rows).Error
	if err != nil {
		logger.Errorf("query find err => %v", err.Error())
		return rows, total
	}
	return rows, total
}

// Insert 新增信息 返回新增数据ID
func (r MMLLog) Insert(param model.MMLLog) int64 {
	param.LogTime = time.Now().UnixMilli()
	// 执行插入
	if err := db.DB("").Create(&param).Error; err != nil {
		logger.Errorf("insert err => %v", err.Error())
		return 0
	}
	return param.ID
}
